<?
# -*- coding: utf-8 -*-
include_once($_SERVER['DOCUMENT_ROOT']."/_glinc/OpalBroker/OpalBroker.php");

class HelloInterface {

    var $interface;
    var $service_name;
    var $full_name;
    var $data;

    function HelloInterface($interface, $service_name) {
        $this->interface = $interface;
        $this->service_name = $service_name;
        $this->full_name = $interface. '.' . $service_name . '.onetapi.pl';

        $this->varsi = array();
    }

    function set_flags($flags) {
        $this->data['SSL'] = $flags['SSL'];
        $this->data['Authentication'] = $flags['Authentication'];
        $this->data['Authorisation'] = $flags['Authorisation'];
    }

    function set_testscript($TestScript) {
        $this->data['TestScript'] = $TestScript;
    }

    function set_alias($alias) {
        $this->data['socket'] = $this->interface . '.' . $alias . '.onetapi.pl';
    }

    function store($result) {
        $result['interfaces'][$this->full_name] = $this->data;
    }
}

class HelloRequest {

    var $service_name;
    var $name;
    var $host;
    var $socket;
    var $ip;
    var $interfaces;

    function HelloRequest($service_name) {
        if( !empty($_SERVER['SERVER_NAME']) && preg_match('/(\-dev\.fx\.vm\.dev.\onet$)|(\-dev\.beta(k)?(\.m\d)?\.onet\.pl$)|(dev\.onet$)/', $_SERVER['SERVER_NAME']) ) {
            $service_name = 'test';
        }
        $this->service_name = $service_name;
        $this->name = $this->service_name;
        $this->host = php_uname('n');
        $this->ip = gethostbyname($this->host);
        $this->port = null;
        $this->svn_tag = null;
        $this->socket = null;

    }

    function set_port($port) {
        $this->port = $port;
    }

    function set_ip($ip) {
        $this->ip = $ip;
    }

    function set_svn_tag($svn_tag) {
        $this->svn_tag = $svn_tag;
    }

    function add_interface($interface, $flags) {
        $this->interfaces[$interface] = new HelloInterface($interface, $this->name);
        $this->interfaces[$interface]->set_flags($flags);
    }

    function add_testscript($interface, $testscript) {
        $this->interfaces[$interface].set_testscript($testscript);
    }

    #function add_alias($interface)

    function store() {
        $result = array(
            'service-name' => $this->service_name,
            'interfaces' => array(),
            'host' => $this->host,
            'port' => (string)$this->port,
            'ip' => $this->ip,
            'svn-tag' => $this->svn_tag,
            'socket' => $this->socket,
        );

        foreach ($this->interfaces as $key=>$val) {
            $this->interfaces[$key]->store(&$result);
        }
        return $result;
    }

    function send($method, $on_success, $on_failure, $on_error) {
        if ($this->port == null)
            user_error("Request port is not set.");
        if ($this->svn_tag == null)
            user_error("Request svn-tag is not set.");
        $broker = new OpalBroker("register.opaladmin.onetapi.pl", "hello" . $this->service_name . "front.onetapi.pl");
        $broker->query($method, $method, $this->store());
        $broker->execute();
        try {
            if ($broker->isOk($method))
                return $on_success($broker->get($method));
            else
                return $on_failure($broker->get_error_message($method));
        } catch (Exception $e) {
            return $on_error($e);
        }

    }
}
?>
