var Loader = require('./lib/core/net/Loader.js').Loader;
var OpalLoader = require('./lib/core/opal/OpalLoader.js').OpalLoader;
var OpalRequest = require('./lib/core/opal/OpalRequest.js').OpalRequest;
var OpalResponse = require('./lib/core/opal/OpalResponse.js').OpalResponse;

var config = {
    "url": "proxy.test.onetapi.pl",
    "method": "query",
    "params": {
        "request": {
            "method": "GET",
            "url": "/",
            "httpVersion": "1.1",
            "headers": {
                "Host": "example.onet.pl",
                "User-Agent": "Mozilla/5.0",
                "Accept": "text/html",
                "Accept-Language": "pl,en-us",
                "Accept-Encoding": "deflate",
                "Accept-Charset": "ISO-8859-2,utf-8",
                "Connection": "keep-alive",
                "X-ONET-APP": [
                    "value1",
                    "value2"
                ]
            },
            "body": ""
        },
        "configuration": {
            "host": "www.onet.pl",
            "port": "80",
            "timeout": 30000
        }
    }
};

var opalRequest = new OpalRequest(config);
var opalLoader = new OpalLoader(opalRequest);
opalLoader.addEventListener(Loader.Event.LOADED, function(e){console.log('LOADED', e.data.getBody().getResult())});
opalLoader.addEventListener(Loader.Event.ERROR, function(e){console.log('ERROR', e)});
opalLoader.load();

setTimeout(function(){}, 3000);