var Class = require("core").Class;
var Request = require("core").Net.Request;
var Response = require("core").Net.Response;
var ProxyRequestProcessor = require("./ProxyRequestProcessor.js").ProxyRequestProcessor;
var Server = require("core").Net.Server;
var YAML = require('core').Yaml.YAML;


/**
 * @class Server Main http server class. Wraps native node.js http object. Creates Request processor instance and dispatch processing. 
 * @param {Class} RequestProcessorClass Subclass of RequestProcessor family.
 */
var ProxyServer = function(){
    this.Extends = Server;
    
    this._configFilePath = './bin/rules.yaml';
    this._configuration = null;
        
    this.initialize = function(){
        this._configuration = YAML.parseFileSync(this._configFilePath).pop();
        this.parent(ProxyRequestProcessor);
    };
    
    /**
     * 
     */
    this.getConfiguration = function(){
        // zwracam kopie konfiguracji
        return JSON.parse(JSON.stringify(this._configuration));
    };
};

ProxyServer.Exception = {};
ProxyServer = new Class(new ProxyServer());
exports.ProxyServer = ProxyServer;
