var Class = require('core').Class;
var RequestResponseDecorator = require("./RequestResponseDecorator.js").RequestResponseDecorator;
var AbstractDecorator = require("core").Decorator.AbstractDecorator;
var Event = require('core').Event.Event;
var ErrorEvent = require('core').Event.ErrorEvent;
var Request = require('core').Net.Request;
var Response = require('core').Net.Response;


/**
 * @class AbsoluteLinkDecorator
 * @extends RequestResponseDecorator
 */
var AbsoluteLinkDecorator = function(){
    this.Extends = RequestResponseDecorator;
    this._request = null;


    /**
     *
     *
     */
    this.decorateRequest = function(request){

        // if request is really Request Object
        if(request instanceof Request){
            this._request = request;
            this.dispatchEvent(new Event(AbstractDecorator.COMPLETE, null));
        } else {
            this.dispatchEvent(new ErrorEvent(AbstractDecorator.ERROR, null, -3200, "AbsoluteLinkDecorator: Give me Request Object please!"));
        }
    }

    /**
     * 
     *
     */
    this.decorateResponse = function(response){
        
        // if response is really Response Object
        if(response instanceof Response){
            if(this._request instanceof Request){
                var body = response.getBody();
                var host = this._request.getHeader('host');
                var pattern = new RegExp("http(.*?)" + host + "/", 'igm');
                body = body.replace(pattern, '/');
                response.setBody(body);
                this.dispatchEvent(new Event(AbstractDecorator.COMPLETE, null));
            } else {
                this.dispatchEvent(new ErrorEvent(AbstractDecorator.ERROR, null, -3200, "AbsoluteLinkDecorator: I dont have Request object from previus decoration!"));
            }
         } else {
            this.dispatchEvent(new ErrorEvent(AbstractDecorator.ERROR, null, -3200, "AbsoluteLinkDecorator: Give me Response Object please!"));
         }
    };

};

AbsoluteLinkDecorator = new Class( new AbsoluteLinkDecorator() );
exports.AbsoluteLinkDecorator = AbsoluteLinkDecorator;
