var Class = require("core").Class;
var RequestResponseDecorator = require("./RequestResponseDecorator.js").RequestResponseDecorator;
var AbstractDecorator = require("core").Decorator.AbstractDecorator;
var Event = require('core').Event.Event;
var ErrorEvent = require('core').Event.ErrorEvent;
var Request = require('core').Net.Request;
var Response = require('core').Net.Response;


/**
 * @class PathDecorator
 * @extends RequestResponseDecorator
 */
var PathDecorator = function(){
    this.Extends = RequestResponseDecorator;
    
    this.decorateRequest = function(request){

        // if request is really Request Object
        if(request instanceof Request){
            if(this.configuration
               && this.configuration.hasOwnProperty('source')
               && this.configuration.hasOwnProperty('destination')){

                // pobieram path z requestu
                var path = request.getPath();
                // bez opcji -g -> podmieni tylko pierwsze wystapienie
                var pattern = new RegExp(this.configuration.source, 'i');
                // podmieniam sciezki
                path = path.replace(pattern, this.configuration.destination);
                // ustawiam sciezke na poprawna
                request.setPath(path);
            }
            this.dispatchEvent(new Event(AbstractDecorator.COMPLETE, null));
        } else {
            this.dispatchEvent(new ErrorEvent(AbstractDecorator.ERROR, null, -3200, "AbsoluteLinkDecorator: Give me Request Object please!"));
        }
    };

};

PathDecorator = new Class( new PathDecorator() );
exports.PathDecorator = PathDecorator;
