describe('ErrorEvent', function(){
    
    var ErrorEvent = require('../../../lib/core/event/ErrorEvent.js').ErrorEvent;
    var ee, msg = "error ocured";

    it('ErrorEvent - creation', function(){
        ee = new ErrorEvent('test', 'data', 13, msg);
        expect(ee.type).toEqual('test');
        expect(ee.data).toEqual('data');
        expect(ee.code).toEqual(13);
        expect(ee.message).toEqual(msg);

    });

    it('ErrorEvent - toHtmlString', function(){
        expect(ee.toHtmlString()).toEqual("<pre>\ttype: test\n\tdata: data\n\ttarget: undefined\n\tcode: 13\n\tmessage: error ocured\n\tcaller: undefined\n</pre>");
    });

    it('ErrorEvent - toHtmlString', function(){
        expect(function(){
            ee = new ErrorEvent('test', new ErrorEvent('inner', 'innerData', -1, msg) , 13, msg);
        }).not.toThrow();

        expect(function(){
            ee = new ErrorEvent('test', {something: 'foo'} , 13, msg);
        }).not.toThrow();

        var json = { code : 13, type : 'test', data : '{"something":"foo"}', message : 'error ocured' };
        expect(ee.toJson()).toEqual(json);
        
    });

});